Index: issm/trunk-jpl/src/c/EnumDefinitions/EnumDefinitions.h
===================================================================
--- issm/trunk-jpl/src/c/EnumDefinitions/EnumDefinitions.h	(revision 14720)
+++ issm/trunk-jpl/src/c/EnumDefinitions/EnumDefinitions.h	(revision 14724)
@@ -141,4 +141,9 @@
 	MaterialsThermalExchangeVelocityEnum,
 	MaterialsThermalconductivityEnum,
+	MaterialsLithosphereShearModulusEnum,
+	MaterialsLithosphereDensityEnum,
+	MaterialsMantleShearModulusEnum,
+	MaterialsMantleViscosityEnum,
+	MaterialsMantleDensityEnum,
 	MeshAverageVertexConnectivityEnum,
 	MeshDimensionEnum,
@@ -219,4 +224,5 @@
 	ThermalStabilizationEnum,
 	ThermalIsenthalpyEnum,
+	GiaLithosphereThicknessEnum,
 	ThicknessEnum,
 	TimesteppingStartTimeEnum,
Index: issm/trunk-jpl/src/c/modules/EnumToStringx/EnumToStringx.cpp
===================================================================
--- issm/trunk-jpl/src/c/modules/EnumToStringx/EnumToStringx.cpp	(revision 14720)
+++ issm/trunk-jpl/src/c/modules/EnumToStringx/EnumToStringx.cpp	(revision 14724)
@@ -146,4 +146,9 @@
 		case MaterialsThermalExchangeVelocityEnum : return "MaterialsThermalExchangeVelocity";
 		case MaterialsThermalconductivityEnum : return "MaterialsThermalconductivity";
+		case MaterialsLithosphereShearModulusEnum : return "MaterialsLithosphereShearModulus";
+		case MaterialsLithosphereDensityEnum : return "MaterialsLithosphereDensity";
+		case MaterialsMantleShearModulusEnum : return "MaterialsMantleShearModulus";
+		case MaterialsMantleViscosityEnum : return "MaterialsMantleViscosity";
+		case MaterialsMantleDensityEnum : return "MaterialsMantleDensity";
 		case MeshAverageVertexConnectivityEnum : return "MeshAverageVertexConnectivity";
 		case MeshDimensionEnum : return "MeshDimension";
@@ -224,4 +229,5 @@
 		case ThermalStabilizationEnum : return "ThermalStabilization";
 		case ThermalIsenthalpyEnum : return "ThermalIsenthalpy";
+		case GiaLithosphereThicknessEnum : return "GiaLithosphereThickness";
 		case ThicknessEnum : return "Thickness";
 		case TimesteppingStartTimeEnum : return "TimesteppingStartTime";
Index: issm/trunk-jpl/src/c/modules/StringToEnumx/StringToEnumx.cpp
===================================================================
--- issm/trunk-jpl/src/c/modules/StringToEnumx/StringToEnumx.cpp	(revision 14720)
+++ issm/trunk-jpl/src/c/modules/StringToEnumx/StringToEnumx.cpp	(revision 14724)
@@ -150,4 +150,9 @@
 	      else if (strcmp(name,"MaterialsThermalExchangeVelocity")==0) return MaterialsThermalExchangeVelocityEnum;
 	      else if (strcmp(name,"MaterialsThermalconductivity")==0) return MaterialsThermalconductivityEnum;
+	      else if (strcmp(name,"MaterialsLithosphereShearModulus")==0) return MaterialsLithosphereShearModulusEnum;
+	      else if (strcmp(name,"MaterialsLithosphereDensity")==0) return MaterialsLithosphereDensityEnum;
+	      else if (strcmp(name,"MaterialsMantleShearModulus")==0) return MaterialsMantleShearModulusEnum;
+	      else if (strcmp(name,"MaterialsMantleViscosity")==0) return MaterialsMantleViscosityEnum;
+	      else if (strcmp(name,"MaterialsMantleDensity")==0) return MaterialsMantleDensityEnum;
 	      else if (strcmp(name,"MeshAverageVertexConnectivity")==0) return MeshAverageVertexConnectivityEnum;
 	      else if (strcmp(name,"MeshDimension")==0) return MeshDimensionEnum;
@@ -228,4 +233,5 @@
 	      else if (strcmp(name,"ThermalStabilization")==0) return ThermalStabilizationEnum;
 	      else if (strcmp(name,"ThermalIsenthalpy")==0) return ThermalIsenthalpyEnum;
+	      else if (strcmp(name,"GiaLithosphereThickness")==0) return GiaLithosphereThicknessEnum;
 	      else if (strcmp(name,"Thickness")==0) return ThicknessEnum;
 	      else if (strcmp(name,"TimesteppingStartTime")==0) return TimesteppingStartTimeEnum;
@@ -255,5 +261,8 @@
 	      else if (strcmp(name,"WeakBalancethicknessSolution")==0) return WeakBalancethicknessSolutionEnum;
 	      else if (strcmp(name,"BedSlopeAnalysis")==0) return BedSlopeAnalysisEnum;
-	      else if (strcmp(name,"BedSlopeSolution")==0) return BedSlopeSolutionEnum;
+         else stage=3;
+   }
+   if(stage==3){
+	      if (strcmp(name,"BedSlopeSolution")==0) return BedSlopeSolutionEnum;
 	      else if (strcmp(name,"BedSlopeXAnalysis")==0) return BedSlopeXAnalysisEnum;
 	      else if (strcmp(name,"BedSlopeYAnalysis")==0) return BedSlopeYAnalysisEnum;
@@ -261,8 +270,5 @@
 	      else if (strcmp(name,"DiagnosticHutterAnalysis")==0) return DiagnosticHutterAnalysisEnum;
 	      else if (strcmp(name,"DiagnosticSolution")==0) return DiagnosticSolutionEnum;
-         else stage=3;
-   }
-   if(stage==3){
-	      if (strcmp(name,"DiagnosticVertAnalysis")==0) return DiagnosticVertAnalysisEnum;
+	      else if (strcmp(name,"DiagnosticVertAnalysis")==0) return DiagnosticVertAnalysisEnum;
 	      else if (strcmp(name,"EnthalpyAnalysis")==0) return EnthalpyAnalysisEnum;
 	      else if (strcmp(name,"EnthalpySolution")==0) return EnthalpySolutionEnum;
@@ -378,5 +384,8 @@
 	      else if (strcmp(name,"Fill")==0) return FillEnum;
 	      else if (strcmp(name,"FractionIncrement")==0) return FractionIncrementEnum;
-	      else if (strcmp(name,"Friction")==0) return FrictionEnum;
+         else stage=4;
+   }
+   if(stage==4){
+	      if (strcmp(name,"Friction")==0) return FrictionEnum;
 	      else if (strcmp(name,"GroundinglineMeltingRate")==0) return GroundinglineMeltingRateEnum;
 	      else if (strcmp(name,"Internal")==0) return InternalEnum;
@@ -384,8 +393,5 @@
 	      else if (strcmp(name,"MassFlux")==0) return MassFluxEnum;
 	      else if (strcmp(name,"MaxPenetration")==0) return MaxPenetrationEnum;
-         else stage=4;
-   }
-   if(stage==4){
-	      if (strcmp(name,"MeltingOffset")==0) return MeltingOffsetEnum;
+	      else if (strcmp(name,"MeltingOffset")==0) return MeltingOffsetEnum;
 	      else if (strcmp(name,"Misfit")==0) return MisfitEnum;
 	      else if (strcmp(name,"NumberNodeToElementConnectivity")==0) return NumberNodeToElementConnectivityEnum;
@@ -501,5 +507,8 @@
 	      else if (strcmp(name,"Adjoint")==0) return AdjointEnum;
 	      else if (strcmp(name,"Colinear")==0) return ColinearEnum;
-	      else if (strcmp(name,"ControlSteady")==0) return ControlSteadyEnum;
+         else stage=5;
+   }
+   if(stage==5){
+	      if (strcmp(name,"ControlSteady")==0) return ControlSteadyEnum;
 	      else if (strcmp(name,"Fset")==0) return FsetEnum;
 	      else if (strcmp(name,"Gradient1")==0) return Gradient1Enum;
@@ -507,8 +516,5 @@
 	      else if (strcmp(name,"Gradient3")==0) return Gradient3Enum;
 	      else if (strcmp(name,"Gradient")==0) return GradientEnum;
-         else stage=5;
-   }
-   if(stage==5){
-	      if (strcmp(name,"GroundinglineMigration")==0) return GroundinglineMigrationEnum;
+	      else if (strcmp(name,"GroundinglineMigration")==0) return GroundinglineMigrationEnum;
 	      else if (strcmp(name,"Gset")==0) return GsetEnum;
 	      else if (strcmp(name,"Index")==0) return IndexEnum;
Index: issm/trunk-jpl/src/c/shared/Numerics/UnitConversion.cpp
===================================================================
--- issm/trunk-jpl/src/c/shared/Numerics/UnitConversion.cpp	(revision 14720)
+++ issm/trunk-jpl/src/c/shared/Numerics/UnitConversion.cpp	(revision 14724)
@@ -71,4 +71,7 @@
 		case MassFluxEnum:                           scale=pow((IssmDouble)10,-12)*yts;break; // (GigaTon/year)
 		case TotalSmbEnum:                           scale=pow((IssmDouble)10,-12)*yts;break; // (GigaTon/year)
+		case GiaLithosphereThicknessEnum:            scale=pow((IssmDouble)10,-3);break; // (km)
+		case MaterialsLithosphereDensityEnum:        scale=pow((IssmDouble)10,-3);break; // (km)
+		case MaterialsMantleDensityEnum:             scale=pow((IssmDouble)10,-3);break; // (km)
 		default: scale=1.0; break;
 	}
Index: issm/trunk-jpl/src/m/classes/gia.m
===================================================================
--- issm/trunk-jpl/src/m/classes/gia.m	(revision 14724)
+++ issm/trunk-jpl/src/m/classes/gia.m	(revision 14724)
@@ -0,0 +1,38 @@
+%GIA class definition
+%
+%   Usage:
+%      gia=gia();
+
+classdef gia
+	properties (SetAccess=public) 
+		lithosphere_thickness         = NaN;
+	end
+	methods
+		function obj = gia(varargin) % {{{
+			switch nargin
+				case 0
+					obj=setdefaultparameters(obj);
+				otherwise
+					error('constructor not supported');
+			end
+		end % }}}
+		function obj = setdefaultparameters(obj) % {{{
+
+		end % }}}
+		function md = checkconsistency(obj,md,solution,analyses) % {{{
+		 
+			if ~ismember(HydrologyAnalysisEnum(),analyses), return; end
+			md = checkfield(md,'gia.lithosphere_thickness','NaN',1,'size',[md.mesh.numberofvertices 1],'>',0);
+
+		end % }}}
+		function disp(obj) % {{{
+			disp(sprintf('   gia parameters:'));
+
+			fielddisplay(obj,'lithosphere_thickness','lithosphere thickness[km]');
+
+		end % }}}
+		function marshall(obj,fid) % {{{
+			WriteData(fid,'data',obj.lithosphere_thickness,'format','DoubleMat','mattype',1,'enum',GiaLithosphereThicknessEnum());
+		end % }}}
+	end
+end
Index: issm/trunk-jpl/src/m/classes/matice.m
===================================================================
--- issm/trunk-jpl/src/m/classes/matice.m	(revision 14720)
+++ issm/trunk-jpl/src/m/classes/matice.m	(revision 14724)
@@ -20,4 +20,12 @@
 		rheology_n   = NaN;
 		rheology_law = '';
+
+		%gia: 
+		lithosphere_shear_modulus  = 0.;
+		lithosphere_density        = 0.;
+		mantle_shear_modulus       = 0.;
+		mantle_viscosity           = 0.;
+		mantle_density             = 0.;
+
 	end
 	methods
@@ -78,4 +86,12 @@
 			%available: none, paterson and arrhenius
 			obj.rheology_law='Paterson';
+
+			%GIA: 
+			obj.lithosphere_shear_modulus  = 6.7*10^10; %(Pa)
+			obj.lithosphere_density        = 3.32; %(g/cm^-3)
+			obj.mantle_shear_modulus       = 1.45*10^11; %(Pa)
+			obj.mantle_viscosity           = 10^21; %(Pa.s)
+			obj.mantle_density             = 3.34; %(g/cm^-3)
+
 		end % }}}
 		function md = checkconsistency(obj,md,solution,analyses) % {{{
@@ -87,4 +103,10 @@
 			md = checkfield(md,'materials.rheology_n','>',0,'size',[md.mesh.numberofelements 1]);
 			md = checkfield(md,'materials.rheology_law','values',{'None' 'Paterson' 'Arrhenius'});
+			md = checkfield(md,'materials.lithosphere_shear_modulus','>',0);
+			md = checkfield(md,'materials.lithosphere_density','>',0);
+			md = checkfield(md,'materials.mantle_shear_modulus','>',0);
+			md = checkfield(md,'materials.mantle_viscosity','>',0);
+			md = checkfield(md,'materials.mantle_density','>',0);
+
 		end % }}}
 		function disp(obj) % {{{
@@ -105,4 +127,9 @@
 			fielddisplay(obj,'rheology_n','Glen''s flow law exponent');
 			fielddisplay(obj,'rheology_law','law for the temperature dependance of the rheology: ''None'', ''Paterson'' or ''Arrhenius''');
+			fielddisplay(obj,'lithosphere_shear_modulus','Lithosphere shear modulus [Pa]');
+			fielddisplay(obj,'lithosphere_density','Lithosphere density [g/cm^-3]');
+			fielddisplay(obj,'mantle_shear_modulus','Mantle shear modulus [Pa]');
+			fielddisplay(obj,'mantle_viscosity','Mantle viscosity [Pa.s]');
+			fielddisplay(obj,'mantle_density','Mantle density [g/cm^-3]');
 		end % }}}
 		function marshall(obj,fid) % {{{
@@ -122,4 +149,10 @@
 			WriteData(fid,'object',obj,'class','materials','fieldname','rheology_n','format','DoubleMat','mattype',2);
 			WriteData(fid,'data',StringToEnum(obj.rheology_law),'enum',MaterialsRheologyLawEnum(),'format','Integer');
+			
+			WriteData(fid,'object',obj,'class','materials','fieldname','lithosphere_shear_modulus','format','Double');
+			WriteData(fid,'object',obj,'class','materials','fieldname','lithosphere_density','format','Double');
+			WriteData(fid,'object',obj,'class','materials','fieldname','mantle_shear_modulus','format','Double');
+			WriteData(fid,'object',obj,'class','materials','fieldname','mantle_viscosity','format','Double');
+			WriteData(fid,'object',obj,'class','materials','fieldname','mantle_density','format','Double');
 		end % }}}
 	end
Index: issm/trunk-jpl/src/m/classes/model/model.m
===================================================================
--- issm/trunk-jpl/src/m/classes/model/model.m	(revision 14720)
+++ issm/trunk-jpl/src/m/classes/model/model.m	(revision 14724)
@@ -36,4 +36,5 @@
 		steadystate      = 0;
 		transient        = 0;
+		gia              = 0;
 
 		autodiff         = 0;
@@ -208,4 +209,5 @@
 			md.geometry.surface=project2d(md,md.geometry.surface,1);
 			md.geometry.thickness=project2d(md,md.geometry.thickness,1);
+			md.gia.lithosphere_thickness=project2d(md,md.gia.lithosphere_thickness,1);
 			md.geometry.bed=project2d(md,md.geometry.bed,1);
 			md.geometry.bathymetry=project2d(md,md.geometry.bathymetry,1);
@@ -753,4 +755,5 @@
 			md.geometry.surface=project3d(md,'vector',md.geometry.surface,'type','node');
 			md.geometry.thickness=project3d(md,'vector',md.geometry.thickness,'type','node');
+			md.gia.lithosphere_thickness=project3d(md,'vector',md.gia.lithosphere_thickness,'type','node');
 			md.geometry.hydrostatic_ratio=project3d(md,'vector',md.geometry.hydrostatic_ratio,'type','node');
 			md.geometry.bed=project3d(md,'vector',md.geometry.bed,'type','node');
@@ -1096,4 +1099,5 @@
 			md.steadystate      = steadystate();
 			md.transient        = transient();
+			md.gia              = gia();
 			md.autodiff         = autodiff();
 			md.flaim            = flaim();
@@ -1132,4 +1136,5 @@
 			disp(sprintf('%19s: %-22s -- %s','steadystate'     ,['[1x1 ' class(obj.steadystate) ']'],'parameters for steadystate solution'));
 			disp(sprintf('%19s: %-22s -- %s','transient'       ,['[1x1 ' class(obj.transient) ']'],'parameters for transient solution'));
+			disp(sprintf('%19s: %-22s -- %s','gia'       ,['[1x1 ' class(obj.gia) ']'],'parameters for gia solution'));
 			disp(sprintf('%19s: %-22s -- %s','autodiff'        ,['[1x1 ' class(obj.autodiff) ']'],'automatic differentiation parameters'));
 			disp(sprintf('%19s: %-22s -- %s','flaim'           ,['[1x1 ' class(obj.flaim) ']'],'flaim parameters'));
Index: issm/trunk-jpl/src/m/enum/EnumDefinitions.py
===================================================================
--- issm/trunk-jpl/src/m/enum/EnumDefinitions.py	(revision 14720)
+++ issm/trunk-jpl/src/m/enum/EnumDefinitions.py	(revision 14724)
@@ -1299,4 +1299,54 @@
 	return StringToEnum('MaterialsThermalconductivity')[0]
 
+def MaterialsLithosphereShearModulusEnum():
+	"""
+	MATERIALSLITHOSPHERESHEARMODULUSENUM - Enum of MaterialsLithosphereShearModulus
+
+	   Usage:
+	      macro=MaterialsLithosphereShearModulusEnum()
+	"""
+
+	return StringToEnum('MaterialsLithosphereShearModulus')[0]
+
+def MaterialsLithosphereDensityEnum():
+	"""
+	MATERIALSLITHOSPHEREDENSITYENUM - Enum of MaterialsLithosphereDensity
+
+	   Usage:
+	      macro=MaterialsLithosphereDensityEnum()
+	"""
+
+	return StringToEnum('MaterialsLithosphereDensity')[0]
+
+def MaterialsMantleShearModulusEnum():
+	"""
+	MATERIALSMANTLESHEARMODULUSENUM - Enum of MaterialsMantleShearModulus
+
+	   Usage:
+	      macro=MaterialsMantleShearModulusEnum()
+	"""
+
+	return StringToEnum('MaterialsMantleShearModulus')[0]
+
+def MaterialsMantleViscosityEnum():
+	"""
+	MATERIALSMANTLEVISCOSITYENUM - Enum of MaterialsMantleViscosity
+
+	   Usage:
+	      macro=MaterialsMantleViscosityEnum()
+	"""
+
+	return StringToEnum('MaterialsMantleViscosity')[0]
+
+def MaterialsMantleDensityEnum():
+	"""
+	MATERIALSMANTLEDENSITYENUM - Enum of MaterialsMantleDensity
+
+	   Usage:
+	      macro=MaterialsMantleDensityEnum()
+	"""
+
+	return StringToEnum('MaterialsMantleDensity')[0]
+
 def MeshAverageVertexConnectivityEnum():
 	"""
@@ -2079,4 +2129,14 @@
 	return StringToEnum('ThermalIsenthalpy')[0]
 
+def GiaLithosphereThicknessEnum():
+	"""
+	GIALITHOSPHERETHICKNESSENUM - Enum of GiaLithosphereThickness
+
+	   Usage:
+	      macro=GiaLithosphereThicknessEnum()
+	"""
+
+	return StringToEnum('GiaLithosphereThickness')[0]
+
 def ThicknessEnum():
 	"""
@@ -5197,4 +5257,4 @@
 	"""
 
-	return 518
-
+	return 524
+
Index: issm/trunk-jpl/src/m/enum/GiaLithosphereThicknessEnum.m
===================================================================
--- issm/trunk-jpl/src/m/enum/GiaLithosphereThicknessEnum.m	(revision 14724)
+++ issm/trunk-jpl/src/m/enum/GiaLithosphereThicknessEnum.m	(revision 14724)
@@ -0,0 +1,11 @@
+function macro=GiaLithosphereThicknessEnum()
+%GIALITHOSPHERETHICKNESSENUM - Enum of GiaLithosphereThickness
+%
+%   WARNING: DO NOT MODIFY THIS FILE
+%            this file has been automatically generated by src/c/EnumDefinitions/Synchronize.sh
+%            Please read src/c/EnumDefinitions/README for more information
+%
+%   Usage:
+%      macro=GiaLithosphereThicknessEnum()
+
+macro=StringToEnum('GiaLithosphereThickness');
Index: issm/trunk-jpl/src/m/enum/MaterialsLithosphereDensityEnum.m
===================================================================
--- issm/trunk-jpl/src/m/enum/MaterialsLithosphereDensityEnum.m	(revision 14724)
+++ issm/trunk-jpl/src/m/enum/MaterialsLithosphereDensityEnum.m	(revision 14724)
@@ -0,0 +1,11 @@
+function macro=MaterialsLithosphereDensityEnum()
+%MATERIALSLITHOSPHEREDENSITYENUM - Enum of MaterialsLithosphereDensity
+%
+%   WARNING: DO NOT MODIFY THIS FILE
+%            this file has been automatically generated by src/c/EnumDefinitions/Synchronize.sh
+%            Please read src/c/EnumDefinitions/README for more information
+%
+%   Usage:
+%      macro=MaterialsLithosphereDensityEnum()
+
+macro=StringToEnum('MaterialsLithosphereDensity');
Index: issm/trunk-jpl/src/m/enum/MaterialsLithosphereShearModulusEnum.m
===================================================================
--- issm/trunk-jpl/src/m/enum/MaterialsLithosphereShearModulusEnum.m	(revision 14724)
+++ issm/trunk-jpl/src/m/enum/MaterialsLithosphereShearModulusEnum.m	(revision 14724)
@@ -0,0 +1,11 @@
+function macro=MaterialsLithosphereShearModulusEnum()
+%MATERIALSLITHOSPHERESHEARMODULUSENUM - Enum of MaterialsLithosphereShearModulus
+%
+%   WARNING: DO NOT MODIFY THIS FILE
+%            this file has been automatically generated by src/c/EnumDefinitions/Synchronize.sh
+%            Please read src/c/EnumDefinitions/README for more information
+%
+%   Usage:
+%      macro=MaterialsLithosphereShearModulusEnum()
+
+macro=StringToEnum('MaterialsLithosphereShearModulus');
Index: issm/trunk-jpl/src/m/enum/MaterialsMantleDensityEnum.m
===================================================================
--- issm/trunk-jpl/src/m/enum/MaterialsMantleDensityEnum.m	(revision 14724)
+++ issm/trunk-jpl/src/m/enum/MaterialsMantleDensityEnum.m	(revision 14724)
@@ -0,0 +1,11 @@
+function macro=MaterialsMantleDensityEnum()
+%MATERIALSMANTLEDENSITYENUM - Enum of MaterialsMantleDensity
+%
+%   WARNING: DO NOT MODIFY THIS FILE
+%            this file has been automatically generated by src/c/EnumDefinitions/Synchronize.sh
+%            Please read src/c/EnumDefinitions/README for more information
+%
+%   Usage:
+%      macro=MaterialsMantleDensityEnum()
+
+macro=StringToEnum('MaterialsMantleDensity');
Index: issm/trunk-jpl/src/m/enum/MaterialsMantleShearModulusEnum.m
===================================================================
--- issm/trunk-jpl/src/m/enum/MaterialsMantleShearModulusEnum.m	(revision 14724)
+++ issm/trunk-jpl/src/m/enum/MaterialsMantleShearModulusEnum.m	(revision 14724)
@@ -0,0 +1,11 @@
+function macro=MaterialsMantleShearModulusEnum()
+%MATERIALSMANTLESHEARMODULUSENUM - Enum of MaterialsMantleShearModulus
+%
+%   WARNING: DO NOT MODIFY THIS FILE
+%            this file has been automatically generated by src/c/EnumDefinitions/Synchronize.sh
+%            Please read src/c/EnumDefinitions/README for more information
+%
+%   Usage:
+%      macro=MaterialsMantleShearModulusEnum()
+
+macro=StringToEnum('MaterialsMantleShearModulus');
Index: issm/trunk-jpl/src/m/enum/MaterialsMantleViscosityEnum.m
===================================================================
--- issm/trunk-jpl/src/m/enum/MaterialsMantleViscosityEnum.m	(revision 14724)
+++ issm/trunk-jpl/src/m/enum/MaterialsMantleViscosityEnum.m	(revision 14724)
@@ -0,0 +1,11 @@
+function macro=MaterialsMantleViscosityEnum()
+%MATERIALSMANTLEVISCOSITYENUM - Enum of MaterialsMantleViscosity
+%
+%   WARNING: DO NOT MODIFY THIS FILE
+%            this file has been automatically generated by src/c/EnumDefinitions/Synchronize.sh
+%            Please read src/c/EnumDefinitions/README for more information
+%
+%   Usage:
+%      macro=MaterialsMantleViscosityEnum()
+
+macro=StringToEnum('MaterialsMantleViscosity');
Index: issm/trunk-jpl/src/m/enum/MaximumNumberOfEnums.m
===================================================================
--- issm/trunk-jpl/src/m/enum/MaximumNumberOfEnums.m	(revision 14720)
+++ issm/trunk-jpl/src/m/enum/MaximumNumberOfEnums.m	(revision 14724)
@@ -9,3 +9,3 @@
 %      macro=MaximumNumberOfEnums()
 
-macro=518;
+macro=524;