Index: issm/trunk-jpl/src/c/Makefile.am
===================================================================
--- issm/trunk-jpl/src/c/Makefile.am	(revision 15052)
+++ issm/trunk-jpl/src/c/Makefile.am	(revision 15053)
@@ -60,5 +60,4 @@
 					./classes/Vertex.h\
 					./classes/Vertex.cpp\
-					./classes/AdolcEdf.h\
 					./classes/Hook.h\
 					./classes/Hook.cpp\
@@ -226,4 +225,6 @@
 					./toolkits/issm/IssmSolver.h\
 					./toolkits/issm/IssmSolver.cpp\
+					./toolkits/adolc/adolcincludes.h\
+					./toolkits/adolc/AdolcEdf.h\
 					./toolkits/ToolkitOptions.h\
 					./toolkits/ToolkitOptions.cpp\
Index: issm/trunk-jpl/src/c/classes/AdolcEdf.h
===================================================================
--- issm/trunk-jpl/src/c/classes/AdolcEdf.h	(revision 15052)
+++ 	(revision )
@@ -1,32 +1,0 @@
-/*
- * adolc_edf.h
- *
- *  Created on: Jun 26, 2012
- *      Author: utke
- */
-
-#ifndef _ADOLC_EDF_H_
-#define _ADOLC_EDF_H_
-
-#ifdef HAVE_CONFIG_H
-	#include <config.h>
-#else
-#error "Cannot compile with HAVE_CONFIG_H symbol! run configure first!"
-#endif
-
-#if defined(_HAVE_ADOLC_) && !defined(_WRAPPERS_)
-
-struct Adolc_edf {
-    ext_diff_fct *myEDF_for_solverx_p;
-    Adolc_edf() : myEDF_for_solverx_p(0) {}
-    inline friend std::ostream& operator << ( ostream&, const Adolc_edf& );
-};
-
-std::ostream& operator << ( std::ostream& out, const Adolc_edf& a) {
-    out << a.myEDF_for_solverx_p;
-    return out;
-}
-
-#endif
-
-#endif
Index: issm/trunk-jpl/src/c/classes/classes.h
===================================================================
--- issm/trunk-jpl/src/c/classes/classes.h	(revision 15052)
+++ issm/trunk-jpl/src/c/classes/classes.h	(revision 15053)
@@ -157,5 +157,4 @@
 #include "./FemModel.h"
 #include "./GiaDeflectionCoreArgs.h"
-#include "./AdolcEdf.h"
 #include "./RiftStruct.h"
 
Index: issm/trunk-jpl/src/c/toolkits/adolc/AdolcEdf.h
===================================================================
--- issm/trunk-jpl/src/c/toolkits/adolc/AdolcEdf.h	(revision 15053)
+++ issm/trunk-jpl/src/c/toolkits/adolc/AdolcEdf.h	(revision 15053)
@@ -0,0 +1,32 @@
+/*
+ * adolc_edf.h
+ *
+ *  Created on: Jun 26, 2012
+ *      Author: utke
+ */
+
+#ifndef _ADOLC_EDF_H_
+#define _ADOLC_EDF_H_
+
+#ifdef HAVE_CONFIG_H
+	#include <config.h>
+#else
+#error "Cannot compile with HAVE_CONFIG_H symbol! run configure first!"
+#endif
+
+#if defined(_HAVE_ADOLC_) && !defined(_WRAPPERS_)
+
+struct Adolc_edf {
+    ext_diff_fct *myEDF_for_solverx_p;
+    Adolc_edf() : myEDF_for_solverx_p(0) {}
+    inline friend std::ostream& operator << ( ostream&, const Adolc_edf& );
+};
+
+std::ostream& operator << ( std::ostream& out, const Adolc_edf& a) {
+    out << a.myEDF_for_solverx_p;
+    return out;
+}
+
+#endif
+
+#endif
Index: issm/trunk-jpl/src/c/toolkits/adolc/adolcincludes.h
===================================================================
--- issm/trunk-jpl/src/c/toolkits/adolc/adolcincludes.h	(revision 15053)
+++ issm/trunk-jpl/src/c/toolkits/adolc/adolcincludes.h	(revision 15053)
@@ -0,0 +1,10 @@
+/* \file adolcincludes.h
+ * \brief all includes for ADOLC layer
+ */
+
+#ifndef _ADOLC_PATCHES_INCLUDES_H_
+#define _ADOLC_PATCHES_INCLUDES_H_
+
+#include "./AdolcEdf.h"
+
+#endif
Index: issm/trunk-jpl/src/c/toolkits/gsl/DenseGslSolve.cpp
===================================================================
--- issm/trunk-jpl/src/c/toolkits/gsl/DenseGslSolve.cpp	(revision 15052)
+++ issm/trunk-jpl/src/c/toolkits/gsl/DenseGslSolve.cpp	(revision 15053)
@@ -11,5 +11,5 @@
 
 #include "../../shared/shared.h"
-#include "../../classes/AdolcEdf.h"
+#include "../adolc/adolcincludes.h"
 #include "../../classes/Params/GenericParam.h"
 #include "../../classes/Params/Parameters.h"
Index: issm/trunk-jpl/src/c/toolkits/toolkits.h
===================================================================
--- issm/trunk-jpl/src/c/toolkits/toolkits.h	(revision 15052)
+++ issm/trunk-jpl/src/c/toolkits/toolkits.h	(revision 15053)
@@ -28,5 +28,12 @@
 #endif
 
+#ifdef _HAVE_ADOLC_
+#include "./adolc/adolcincludes.h"
+#endif
+
+#ifdef _HAVE_TRIANGLE_
 #include "./triangle/triangleincludes.h"
+#endif
+
 #include "./objects/toolkitobjects.h"
 #include "./toolkitsenums.h"