Index: issm/trunk-jpl/src/c/shared/Numerics/UnitConversion.cpp
===================================================================
--- issm/trunk-jpl/src/c/shared/Numerics/UnitConversion.cpp	(revision 15124)
+++ issm/trunk-jpl/src/c/shared/Numerics/UnitConversion.cpp	(revision 15125)
@@ -49,12 +49,7 @@
 		case HydrologyWaterVyEnum:                   scale=yts;break;     //m/yr
 		case VxEnum:                                 scale=yts;break;     //m/yr
-		case InversionVxObsEnum:                     scale=yts;break;     //m/yr
 		case VyEnum:                                 scale=yts;break;     //m/yr
-		case InversionVyObsEnum:                     scale=yts;break;     //m/yr
 		case VzEnum:                                 scale=yts;break;     //m/yr
-		case InversionVzObsEnum:                     scale=yts;break;     //m/yr
 		case VelEnum:                                scale=yts;break;     //m/yr
-		case InversionVelObsEnum:                    scale=yts;break;     //m/yr
-		case BalancethicknessThickeningRateEnum:     scale=yts;break;     //m/yr
 		case BasalforcingsMeltingRateEnum:           scale=yts;break;     //m/yr
 		case BasalforcingsMeltingRateCorrectionEnum: scale=yts;break;     //m/yr
@@ -67,7 +62,4 @@
 		case MassFluxEnum:                           scale=pow((IssmDouble)10,-12)*yts;break; // (GigaTon/year)
 		case TotalSmbEnum:                           scale=pow((IssmDouble)10,-12)*yts;break; // (GigaTon/year)
-		case GiaLithosphereThicknessEnum:            scale=pow((IssmDouble)10,-3);break; // (km)
-		case MaterialsLithosphereDensityEnum:        scale=pow((IssmDouble)10,-3);break; // (km)
-		case MaterialsMantleDensityEnum:             scale=pow((IssmDouble)10,-3);break; // (km)
 		default: scale=1.0; break;
 	}
Index: issm/trunk-jpl/src/m/classes/balancethickness.m
===================================================================
--- issm/trunk-jpl/src/m/classes/balancethickness.m	(revision 15124)
+++ issm/trunk-jpl/src/m/classes/balancethickness.m	(revision 15125)
@@ -42,6 +42,9 @@
 		end % }}}
 		function marshall(obj,fid) % {{{
+
+			yts=365.0*24.0*3600.0;
+
 			WriteData(fid,'object',obj,'fieldname','spcthickness','format','DoubleMat','mattype',1);
-			WriteData(fid,'object',obj,'fieldname','thickening_rate','format','DoubleMat','mattype',1);
+			WriteData(fid,'object',obj,'fieldname','thickening_rate','format','DoubleMat','mattype',1,'scale',1./yts);
 			WriteData(fid,'object',obj,'fieldname','stabilization','format','Integer');
 		end % }}}
Index: issm/trunk-jpl/src/m/classes/balancethickness.py
===================================================================
--- issm/trunk-jpl/src/m/classes/balancethickness.py	(revision 15124)
+++ issm/trunk-jpl/src/m/classes/balancethickness.py	(revision 15125)
@@ -49,6 +49,9 @@
 	# }}}
 	def marshall(self,fid):    # {{{
+
+		yts=365.0*24.0*3600.0
+
 		WriteData(fid,'object',self,'fieldname','spcthickness','format','DoubleMat','mattype',1)
-		WriteData(fid,'object',self,'fieldname','thickening_rate','format','DoubleMat','mattype',1)
+		WriteData(fid,'object',self,'fieldname','thickening_rate','format','DoubleMat','mattype',1,'scale',1./yts)
 		WriteData(fid,'object',self,'fieldname','stabilization','format','Integer')
 	# }}}
Index: issm/trunk-jpl/src/m/classes/gia.m
===================================================================
--- issm/trunk-jpl/src/m/classes/gia.m	(revision 15124)
+++ issm/trunk-jpl/src/m/classes/gia.m	(revision 15125)
@@ -52,5 +52,5 @@
 
 			fielddisplay(obj,'mantle_viscosity','mantle viscosity[Pa s]');
-			fielddisplay(obj,'lithosphere_thickness','lithosphere thickness[km]');
+			fielddisplay(obj,'lithosphere_thickness','lithosphere thickness (km)');
 			fielddisplay(obj,'output_rates','1: fetch w solution (m) (default). 2: fetch dw/dt (mm/yr). See irate in GiaDeflectionCore');
 			fielddisplay(obj,'cross_section_shape','1: square-edged (default). 2: elliptical.  See iedge in GiaDeflectionCore');
@@ -59,5 +59,5 @@
 		function marshall(obj,fid) % {{{
 			WriteData(fid,'object',obj,'fieldname','mantle_viscosity','format','DoubleMat','mattype',1);
-			WriteData(fid,'object',obj,'fieldname','lithosphere_thickness','format','DoubleMat','mattype',1);
+			WriteData(fid,'object',obj,'fieldname','lithosphere_thickness','format','DoubleMat','mattype',1,'scale',10^3); %from km to m
 			WriteData(fid,'object',obj,'fieldname','output_rates','format','Integer');
 			WriteData(fid,'object',obj,'fieldname','cross_section_shape','format','Integer');
Index: issm/trunk-jpl/src/m/classes/gia.py
===================================================================
--- issm/trunk-jpl/src/m/classes/gia.py	(revision 15124)
+++ issm/trunk-jpl/src/m/classes/gia.py	(revision 15125)
@@ -26,7 +26,7 @@
 		string='   gia solution parameters:' 
 		
-		string="%s\n%s"%(string,fielddisplay(self,'mantle_viscosity','mantle viscosity constraints (NaN means no constraint) [Pa s]'))
-		string="%s\n%s"%(string,fielddisplay(self,'lithosphere_thickness','lithosphere thickness constraints (NaN means no constraint) [m]'))
-		string="%s\n%s"%(string,fielddisplay(self,'output_rates','1: deflection (w) [m], 2: rate of deflection (dw/dt) [mm/yr]'))
+		string="%s\n%s"%(string,fielddisplay(self,'mantle_viscosity','mantle viscosity constraints (NaN means no constraint) (Pa s)'))
+		string="%s\n%s"%(string,fielddisplay(self,'lithosphere_thickness','lithosphere thickness constraints (NaN means no constraint) (m)'))
+		string="%s\n%s"%(string,fielddisplay(self,'output_rates','1: deflection (w) (m), 2: rate of deflection (dw/dt) (mm/yr)'))
 		string="%s\n%s"%(string,fielddisplay(self,'cross_section_shape',"1: square-edged, 2: elliptical-edged surface"))
 		return string
@@ -56,6 +56,7 @@
 	# }}}
 	def marshall(self,fid):    # {{{
+
 		WriteData(fid,'object',self,'fieldname','mantle_viscosity','format','DoubleMat','mattype',1);
-		WriteData(fid,'object',self,'fieldname','lithosphere_thickness','format','DoubleMat','mattype',1);
+		WriteData(fid,'object',self,'fieldname','lithosphere_thickness','format','DoubleMat','mattype',1,'scale',10.**3.);
 		WriteData(fid,'object',self,'fieldname','output_rates','format','Integer');
 		WriteData(fid,'object',self,'fieldname','cross_section_shape','format','Integer');
Index: issm/trunk-jpl/src/m/classes/inversion.m
===================================================================
--- issm/trunk-jpl/src/m/classes/inversion.m	(revision 15124)
+++ issm/trunk-jpl/src/m/classes/inversion.m	(revision 15125)
@@ -163,4 +163,6 @@
 		function marshall(obj,fid) % {{{
 
+			yts=365.0*24.0*3600.0;
+
 			WriteData(fid,'object',obj,'fieldname','iscontrol','format','Boolean');
 			WriteData(fid,'object',obj,'fieldname','tao','format','Boolean');
@@ -176,7 +178,7 @@
 			WriteData(fid,'object',obj,'fieldname','step_threshold','format','DoubleMat','mattype',3);
 			WriteData(fid,'object',obj,'fieldname','gradient_only','format','Boolean');
-			WriteData(fid,'object',obj,'fieldname','vx_obs','format','DoubleMat','mattype',1);
-			WriteData(fid,'object',obj,'fieldname','vy_obs','format','DoubleMat','mattype',1);
-			WriteData(fid,'object',obj,'fieldname','vz_obs','format','DoubleMat','mattype',1);
+			WriteData(fid,'object',obj,'fieldname','vx_obs','format','DoubleMat','mattype',1,'scale',1./yts);
+			WriteData(fid,'object',obj,'fieldname','vy_obs','format','DoubleMat','mattype',1,'scale',1./yts);
+			WriteData(fid,'object',obj,'fieldname','vz_obs','format','DoubleMat','mattype',1,'scale',1./yts);
 			WriteData(fid,'object',obj,'fieldname','thickness_obs','format','DoubleMat','mattype',1);
 
Index: issm/trunk-jpl/src/m/classes/inversion.py
===================================================================
--- issm/trunk-jpl/src/m/classes/inversion.py	(revision 15124)
+++ issm/trunk-jpl/src/m/classes/inversion.py	(revision 15125)
@@ -145,4 +145,6 @@
 	def marshall(self,fid):    # {{{
 
+		yts=365.0*24.0*3600.0
+
 		WriteData(fid,'object',self,'fieldname','iscontrol','format','Boolean')
 		WriteData(fid,'object',self,'fieldname','tao','format','Boolean')
@@ -159,7 +161,7 @@
 		WriteData(fid,'object',self,'fieldname','step_threshold','format','DoubleMat','mattype',3)
 		WriteData(fid,'object',self,'fieldname','gradient_only','format','Boolean')
-		WriteData(fid,'object',self,'fieldname','vx_obs','format','DoubleMat','mattype',1)
-		WriteData(fid,'object',self,'fieldname','vy_obs','format','DoubleMat','mattype',1)
-		WriteData(fid,'object',self,'fieldname','vz_obs','format','DoubleMat','mattype',1)
+		WriteData(fid,'object',self,'fieldname','vx_obs','format','DoubleMat','mattype',1,'scale',1./yts)
+		WriteData(fid,'object',self,'fieldname','vy_obs','format','DoubleMat','mattype',1,'scale',1./yts)
+		WriteData(fid,'object',self,'fieldname','vz_obs','format','DoubleMat','mattype',1,'scale',1./yts)
 		WriteData(fid,'object',self,'fieldname','thickness_obs','format','DoubleMat','mattype',1)
 
Index: issm/trunk-jpl/src/m/classes/matdamageice.m
===================================================================
--- issm/trunk-jpl/src/m/classes/matdamageice.m	(revision 15124)
+++ issm/trunk-jpl/src/m/classes/matdamageice.m	(revision 15125)
@@ -152,7 +152,7 @@
 
 			WriteData(fid,'object',obj,'class','materials','fieldname','lithosphere_shear_modulus','format','Double');
-			WriteData(fid,'object',obj,'class','materials','fieldname','lithosphere_density','format','Double');
+			WriteData(fid,'object',obj,'class','materials','fieldname','lithosphere_density','format','Double','scale',10^3);
 			WriteData(fid,'object',obj,'class','materials','fieldname','mantle_shear_modulus','format','Double');
-			WriteData(fid,'object',obj,'class','materials','fieldname','mantle_density','format','Double');
+			WriteData(fid,'object',obj,'class','materials','fieldname','mantle_density','format','Double','scale',10^3);
 
 		end % }}}
Index: issm/trunk-jpl/src/m/classes/matdamageice.py
===================================================================
--- issm/trunk-jpl/src/m/classes/matdamageice.py	(revision 15124)
+++ issm/trunk-jpl/src/m/classes/matdamageice.py	(revision 15125)
@@ -147,6 +147,6 @@
 
 		WriteData(fid,'object',self,'class','materials','fieldname','lithosphere_shear_modulus','format','Double');
-		WriteData(fid,'object',self,'class','materials','fieldname','lithosphere_density','format','Double');
+		WriteData(fid,'object',self,'class','materials','fieldname','lithosphere_density','format','Double','scale',10.**3.);
 		WriteData(fid,'object',self,'class','materials','fieldname','mantle_shear_modulus','format','Double');
-		WriteData(fid,'object',self,'class','materials','fieldname','mantle_density','format','Double');
+		WriteData(fid,'object',self,'class','materials','fieldname','mantle_density','format','Double','scale',10.**3.);
 	# }}}
Index: issm/trunk-jpl/src/m/classes/matice.m
===================================================================
--- issm/trunk-jpl/src/m/classes/matice.m	(revision 15124)
+++ issm/trunk-jpl/src/m/classes/matice.m	(revision 15125)
@@ -147,7 +147,7 @@
 
 			WriteData(fid,'object',obj,'class','materials','fieldname','lithosphere_shear_modulus','format','Double');
-			WriteData(fid,'object',obj,'class','materials','fieldname','lithosphere_density','format','Double');
+			WriteData(fid,'object',obj,'class','materials','fieldname','lithosphere_density','format','Double','scale',10^3);
 			WriteData(fid,'object',obj,'class','materials','fieldname','mantle_shear_modulus','format','Double');
-			WriteData(fid,'object',obj,'class','materials','fieldname','mantle_density','format','Double');
+			WriteData(fid,'object',obj,'class','materials','fieldname','mantle_density','format','Double','scale',10^3);
 		end % }}}
 	end
Index: issm/trunk-jpl/src/m/classes/matice.py
===================================================================
--- issm/trunk-jpl/src/m/classes/matice.py	(revision 15124)
+++ issm/trunk-jpl/src/m/classes/matice.py	(revision 15125)
@@ -139,6 +139,6 @@
 
 		WriteData(fid,'object',self,'class','materials','fieldname','lithosphere_shear_modulus','format','Double');
-		WriteData(fid,'object',self,'class','materials','fieldname','lithosphere_density','format','Double');
+		WriteData(fid,'object',self,'class','materials','fieldname','lithosphere_density','format','Double','scale',10.**3.);
 		WriteData(fid,'object',self,'class','materials','fieldname','mantle_shear_modulus','format','Double');
-		WriteData(fid,'object',self,'class','materials','fieldname','mantle_density','format','Double');
+		WriteData(fid,'object',self,'class','materials','fieldname','mantle_density','format','Double','scale',10.**3.);
 	# }}}
Index: issm/trunk-jpl/src/m/classes/timestepping.py
===================================================================
--- issm/trunk-jpl/src/m/classes/timestepping.py	(revision 15124)
+++ issm/trunk-jpl/src/m/classes/timestepping.py	(revision 15125)
@@ -60,5 +60,5 @@
 	def marshall(self,fid):    # {{{
 
-		yts=365.0*24.0*3600.0;
+		yts=365.0*24.0*3600.0
 
 		WriteData(fid,'object',self,'fieldname','start_time','format','Double','scale',yts)