Index: issm/trunk-jpl/src/dox/issm.dox
===================================================================
--- issm/trunk-jpl/src/dox/issm.dox	(revision 15397)
+++ issm/trunk-jpl/src/dox/issm.dox	(revision 15398)
@@ -47,26 +47,20 @@
 </th>
 <tr>
-<th  bgcolor=#FFFFFF style="text-align:left;"> C++ </th><td  bgcolor=#FFFFFF style="text-align:right;">469</td><td  bgcolor=#FFFFFF style="text-align:right;">14505</td><td  bgcolor=#FFFFFF style="text-align:right;">16993</td><td  bgcolor=#FFFFFF style="text-align:right;">58467</td><td  bgcolor=#FFFFFF style="text-align:right;">89965</td>
+<th  bgcolor=#FFFFFF style="text-align:left;"> C++ </th><td  bgcolor=#FFFFFF style="text-align:right;">478</td><td  bgcolor=#FFFFFF style="text-align:right;">14993</td><td  bgcolor=#FFFFFF style="text-align:right;">17509</td><td  bgcolor=#FFFFFF style="text-align:right;">60128</td><td  bgcolor=#FFFFFF style="text-align:right;">92630</td>
 </tr>
 <tr>
-<th  bgcolor=#C6E2FF style="text-align:left;"> MATLAB </th><td  bgcolor=#C6E2FF style="text-align:right;">959</td><td  bgcolor=#C6E2FF style="text-align:right;">6773</td><td  bgcolor=#C6E2FF style="text-align:right;">13598</td><td  bgcolor=#C6E2FF style="text-align:right;">31759</td><td  bgcolor=#C6E2FF style="text-align:right;">52130</td>
+<th  bgcolor=#C6E2FF style="text-align:left;"> MATLAB </th><td  bgcolor=#C6E2FF style="text-align:right;">1037</td><td  bgcolor=#C6E2FF style="text-align:right;">7053</td><td  bgcolor=#C6E2FF style="text-align:right;">14331</td><td  bgcolor=#C6E2FF style="text-align:right;">33157</td><td  bgcolor=#C6E2FF style="text-align:right;">54541</td>
 </tr>
 <tr>
-<th  bgcolor=#FFFFFF style="text-align:left;"> C/C++  Header </th><td  bgcolor=#FFFFFF style="text-align:right;">365</td><td  bgcolor=#FFFFFF style="text-align:right;">2786</td><td  bgcolor=#FFFFFF style="text-align:right;">2931</td><td  bgcolor=#FFFFFF style="text-align:right;">12036</td><td  bgcolor=#FFFFFF style="text-align:right;">17753</td>
+<th  bgcolor=#FFFFFF style="text-align:left;"> C/C++  Header </th><td  bgcolor=#FFFFFF style="text-align:right;">381</td><td  bgcolor=#FFFFFF style="text-align:right;">3146</td><td  bgcolor=#FFFFFF style="text-align:right;">3358</td><td  bgcolor=#FFFFFF style="text-align:right;">13275</td><td  bgcolor=#FFFFFF style="text-align:right;">19779</td>
 </tr>
 <tr>
-<th  bgcolor=#C6E2FF style="text-align:left;"> Python </th><td  bgcolor=#C6E2FF style="text-align:right;">113</td><td  bgcolor=#C6E2FF style="text-align:right;">3445</td><td  bgcolor=#C6E2FF style="text-align:right;">4852</td><td  bgcolor=#C6E2FF style="text-align:right;">7316</td><td  bgcolor=#C6E2FF style="text-align:right;">15613</td>
+<th  bgcolor=#C6E2FF style="text-align:left;"> Python </th><td  bgcolor=#C6E2FF style="text-align:right;">115</td><td  bgcolor=#C6E2FF style="text-align:right;">4054</td><td  bgcolor=#C6E2FF style="text-align:right;">6697</td><td  bgcolor=#C6E2FF style="text-align:right;">7601</td><td  bgcolor=#C6E2FF style="text-align:right;">18352</td>
 </tr>
 <tr>
-<th  bgcolor=#FFFFFF style="text-align:left;"> Java </th><td  bgcolor=#FFFFFF style="text-align:right;">23</td><td  bgcolor=#FFFFFF style="text-align:right;">460</td><td  bgcolor=#FFFFFF style="text-align:right;">416</td><td  bgcolor=#FFFFFF style="text-align:right;">4061</td><td  bgcolor=#FFFFFF style="text-align:right;">4937</td>
+<th  bgcolor=#FFFFFF style="text-align:left;"> m4 </th><td  bgcolor=#FFFFFF style="text-align:right;">2</td><td  bgcolor=#FFFFFF style="text-align:right;">213</td><td  bgcolor=#FFFFFF style="text-align:right;">6</td><td  bgcolor=#FFFFFF style="text-align:right;">1512</td><td  bgcolor=#FFFFFF style="text-align:right;">1731</td>
 </tr>
 <tr>
-<th  bgcolor=#C6E2FF style="text-align:left;"> m4 </th><td  bgcolor=#C6E2FF style="text-align:right;">2</td><td  bgcolor=#C6E2FF style="text-align:right;">197</td><td  bgcolor=#C6E2FF style="text-align:right;">6</td><td  bgcolor=#C6E2FF style="text-align:right;">1401</td><td  bgcolor=#C6E2FF style="text-align:right;">1604</td>
-</tr>
-<tr>
-<th  bgcolor=#FFFFFF style="text-align:left;"> XML </th><td  bgcolor=#FFFFFF style="text-align:right;">38</td><td  bgcolor=#FFFFFF style="text-align:right;">89</td><td  bgcolor=#FFFFFF style="text-align:right;">10</td><td  bgcolor=#FFFFFF style="text-align:right;">783</td><td  bgcolor=#FFFFFF style="text-align:right;">882</td>
-</tr>
-<tr>
-<th  bgcolor=#C6E2FF style="text-align:left;"> CMake </th><td  bgcolor=#C6E2FF style="text-align:right;">163</td><td  bgcolor=#C6E2FF style="text-align:right;">0</td><td  bgcolor=#C6E2FF style="text-align:right;">871</td><td  bgcolor=#C6E2FF style="text-align:right;">631</td><td  bgcolor=#C6E2FF style="text-align:right;">1502</td>
+<th  bgcolor=#C6E2FF style="text-align:left;"> CMake </th><td  bgcolor=#C6E2FF style="text-align:right;">158</td><td  bgcolor=#C6E2FF style="text-align:right;">0</td><td  bgcolor=#C6E2FF style="text-align:right;">835</td><td  bgcolor=#C6E2FF style="text-align:right;">598</td><td  bgcolor=#C6E2FF style="text-align:right;">1433</td>
 </tr>
 <tr>
@@ -74,14 +68,14 @@
 </tr>
 <tr>
-<th  bgcolor=#C6E2FF style="text-align:left;"> Bourne  Shell </th><td  bgcolor=#C6E2FF style="text-align:right;">3</td><td  bgcolor=#C6E2FF style="text-align:right;">56</td><td  bgcolor=#C6E2FF style="text-align:right;">73</td><td  bgcolor=#C6E2FF style="text-align:right;">248</td><td  bgcolor=#C6E2FF style="text-align:right;">377</td>
+<th  bgcolor=#C6E2FF style="text-align:left;"> Fortran </th><td  bgcolor=#C6E2FF style="text-align:right;">77</td><td  bgcolor=#C6E2FF style="text-align:right;">7</td><td  bgcolor=#C6E2FF style="text-align:right;">4</td><td  bgcolor=#C6E2FF style="text-align:right;">302</td><td  bgcolor=#C6E2FF style="text-align:right;">365</td><td  bgcolor=#C6E2FF style="text-align:right;">678</td>
 </tr>
 <tr>
-<th  bgcolor=#FFFFFF style="text-align:left;"> Perl </th><td  bgcolor=#FFFFFF style="text-align:right;">1</td><td  bgcolor=#FFFFFF style="text-align:right;">6</td><td  bgcolor=#FFFFFF style="text-align:right;">9</td><td  bgcolor=#FFFFFF style="text-align:right;">196</td><td  bgcolor=#FFFFFF style="text-align:right;">211</td>
+<th  bgcolor=#FFFFFF style="text-align:left;"> Bourne  Shell </th><td  bgcolor=#FFFFFF style="text-align:right;">2</td><td  bgcolor=#FFFFFF style="text-align:right;">58</td><td  bgcolor=#FFFFFF style="text-align:right;">71</td><td  bgcolor=#FFFFFF style="text-align:right;">252</td><td  bgcolor=#FFFFFF style="text-align:right;">381</td>
 </tr>
 <tr>
-<th  bgcolor=#C6E2FF style="text-align:left;"> C </th><td  bgcolor=#C6E2FF style="text-align:right;">2</td><td  bgcolor=#C6E2FF style="text-align:right;">10</td><td  bgcolor=#C6E2FF style="text-align:right;">3</td><td  bgcolor=#C6E2FF style="text-align:right;">81</td><td  bgcolor=#C6E2FF style="text-align:right;">94</td>
+<th  bgcolor=#C6E2FF style="text-align:left;"> Perl </th><td  bgcolor=#C6E2FF style="text-align:right;">1</td><td  bgcolor=#C6E2FF style="text-align:right;">6</td><td  bgcolor=#C6E2FF style="text-align:right;">9</td><td  bgcolor=#C6E2FF style="text-align:right;">196</td><td  bgcolor=#C6E2FF style="text-align:right;">211</td>
 </tr>
 <tr>
-<th  bgcolor=#FFFFFF style="text-align:left;"> SUM: </th><td  bgcolor=#FFFFFF style="text-align:right;">2147</td><td  bgcolor=#FFFFFF style="text-align:right;">28423</td><td  bgcolor=#FFFFFF style="text-align:right;">39762</td><td  bgcolor=#FFFFFF style="text-align:right;">117349</td><td  bgcolor=#FFFFFF style="text-align:right;">185534</td>
+<th  bgcolor=#FFFFFF style="text-align:left;"> SUM: </th><td  bgcolor=#FFFFFF style="text-align:right;">2190</td><td  bgcolor=#FFFFFF style="text-align:right;">29623</td><td  bgcolor=#FFFFFF style="text-align:right;">43118</td><td  bgcolor=#FFFFFF style="text-align:right;">117454</td><td  bgcolor=#FFFFFF style="text-align:right;">190195</td>
 </tr>
 </table>